# AddTyping

> 1.0.0

Typing Effect Animation jQuery Plugin

```html
<div data-addui='typing'>
  <span>Hello World</span>
</div>
```

![](res/typing.gif)

## How to Use
Copy the files from the distribution directory 'dist/' into your project and include them into your document.

Create an HTML element and give it a `data-addui="typing"` attribute. Give it some children with text. The children's text will be typed out.

### Multiple
If you would like the animation to type out multiple strings of text create multiple children within the `data-addui="typing"` element.

```html
<div data-addui='typing'>
  <span>Hello</span>
  <span>What is your name?</span>
  <span>Goodbye</span>
</div>
```

![](res/multiple.gif)

## Settings
These settings can be changed by setting the `data-{setting_name}="{setting_value}"` attribute.

### `speed`
*defualt =* `350`
How many milliseconds between character types.

### `variance`
*default =* `100`
Each key stroke's speed will vary (+ or -) up to this amount (milliseconds) giving it a more human like look.

### `backspace`
*default =* `true`
Should the text be backspaced after completed (at double the speed), or should it be instantly deleted?

### `pause`
*default =* `3000`
How long (milliseconds) should the text be displayed for after it has finished being typed and before deletion?

### `caret`
*default =* `true`
Should the caret be displayed?

# License

This software is property of [Dustin Poissant](http://github.com/dustinpoissant/).

This software is distributed AS-IS with no warranties/guarantees either expressed or implied.

This software is Licensed under [CC BY-NC-SA 3.0 US](https://creativecommons.org/licenses/by-nc-sa/3.0/us/).
